diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
index 6a905276a..d2ef59c6b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerEntryComponent.java
@@ -3,7 +3,8 @@ package net.minecraft.client.gui.server;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.paged.PageComponent;
 import net.minecraft.client.render.font.Alignment;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.Global;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
@@ -27,50 +28,50 @@ public class ServerEntryComponent implements PageComponent {
 
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        Tessellator t = Tessellator.instance;
-        if (entry.icon != null) {
-            entry.icon.bind();
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        if (this.entry.icon != null) {
+            this.entry.icon.bind();
             t.startDrawingQuads();
             t.drawRectangleWithUV(x + 1, y + 1, 24, 24, 0, 0, 1, 1);
             t.draw();
         }
 
-        mc.font.render(t, entry.getName("Unknown"), x + 24 + 3, y + 2).setShadow().call();
-        if (entry.motd != null) {
+        this.mc.font.render(this.entry.getName("Unknown"), x + 24 + 3, y + 2).setShadow().call();
+        if (this.entry.motd != null) {
             stringBuilder.setLength(0);
-            stringBuilder.append(TextFormatting.GRAY).append(entry.motd);
-            stringBuilder.setLength(Math.max((width - 16), 0) / mc.font.getFont().charWidth('m'));
-            mc.font.renderWidthConstrained(t, stringBuilder, x + 24 + 3, mc.font.getLastEndingY(), width).setShadow().call();
+            stringBuilder.append(TextFormatting.GRAY).append(this.entry.motd);
+            stringBuilder.setLength(Math.max((width - 16), 0) / this.mc.font.getFont().charWidth('m'));
+            this.mc.font.renderWidthConstrained(stringBuilder, x + 24 + 3, this.mc.font.getLastEndingY(), width).setShadow().call();
         }
 
-        if (!entry.isUp) {
+        if (!this.entry.isUp) {
             stringBuilder.setLength(0);
             stringBuilder.append(I18n.getInstance().translateKey("gui.select_server.label.down"));
-            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
-        } else if (entry.protocolVersion != Global.MP_PROTOCOL_VERSION) {
+            this.mc.font.renderWidthConstrained(stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
+        } else if (this.entry.protocolVersion != Global.MP_PROTOCOL_VERSION) {
             stringBuilder.setLength(0);
             stringBuilder.append(I18n.getInstance().translateKey("gui.select_server.label.outdated"));
-            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
+            this.mc.font.renderWidthConstrained(stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
 //            stringBuilder.setLength(0);
 //            stringBuilder.append(entry.version);
 //            mc.font.renderWidthConstrained(t, stringBuilder, x, mc.font.getLastEndingY(), width - 2).setShadow().setColor(0xFF0000).setAlignment(Alignment.RIGHT).call();
-        } else if (!entry.dirty) {
+        } else if (!this.entry.dirty) {
             stringBuilder.setLength(0);
-            stringBuilder.append(entry.playerCount).append("/").append(entry.playerCap);
-            mc.font.renderWidthConstrained(t, stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
+            stringBuilder.append(this.entry.playerCount).append("/").append(this.entry.playerCap);
+            this.mc.font.renderWidthConstrained(stringBuilder, x, y + 2, width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
             stringBuilder.setLength(0);
-            stringBuilder.append(entry.ping).append(" ms");
-            mc.font.renderWidthConstrained(t, stringBuilder, x, mc.font.getLastEndingY(), width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
+            stringBuilder.append(this.entry.ping).append(" ms");
+            this.mc.font.renderWidthConstrained(stringBuilder, x, this.mc.font.getLastEndingY(), width - 2).setShadow().setColor(0xFFFF00).setAlignment(Alignment.RIGHT).call();
         }
 
-        if (entry == attachedScreen.selectedEntry) {
-            attachedScreen.drawBox(x, y, x + width, y + getHeight(), 0xFFFFFFFF, 1);
+        if (this.entry == this.attachedScreen.selectedEntry) {
+            this.attachedScreen.drawBox(x, y, x + width, y + getHeight(), 0xFFFFFFFF, 1);
         }
     }
 
     @Override
     public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        attachedScreen.setSelectedEntry(entry);
+        this.attachedScreen.setSelectedEntry(this.entry);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java
index 7010e1a4c..49057feb8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerListenerThread.java
@@ -12,7 +12,7 @@ import java.net.MulticastSocket;
 import java.util.HashMap;
 import java.util.Map;
 
-public class ServerListenerThread extends Thread{
+public class ServerListenerThread extends Thread {
     private static final Logger LOGGER = LogUtils.getLogger();
     public final @NotNull ScreenSelectServer attachedScreen;
     public final @NotNull ServerManager serverManager;
@@ -32,34 +32,34 @@ public class ServerListenerThread extends Thread{
         boolean multiCastAlive = false;
         InetAddress group = null;
         try {
-            multicastSocket = new MulticastSocket(4445);
+            this.multicastSocket = new MulticastSocket(4445);
             group = InetAddress.getByName("224.0.2.61");
-            multicastSocket.joinGroup(group);
+            this.multicastSocket.joinGroup(group);
             multiCastAlive = true;
         } catch (IOException e) {
             LOGGER.error("", e);
         }
-        while (keepAlive) {
+        while (this.keepAlive) {
             try {
-                serverManager.idToEntryLock.lock();
+                this.serverManager.idToEntryLock.lock();
                 try {
-                    for (ServerEntry entry : serverManager.idToEntryMap.values()) {
-                        if (entry.dirty && !pingThreads.containsKey(entry)) {
+                    for (ServerEntry entry : this.serverManager.idToEntryMap.values()) {
+                        if (entry.dirty && !this.pingThreads.containsKey(entry)) {
                             entry.dirty = false;
-                            synchronized (pingThreads) {
+                            synchronized (this.pingThreads) {
                                 ThreadPingServer threadPingServer2 = new ThreadPingServer(this, entry);
-                                pingThreads.put(entry, threadPingServer2);
+                                this.pingThreads.put(entry, threadPingServer2);
                                 threadPingServer2.start();
                             }
                         }
                     }
                 } finally {
-                    serverManager.idToEntryLock.unlock();
+                    this.serverManager.idToEntryLock.unlock();
                 }
                 if (multiCastAlive) {
                     try {
-                        DatagramPacket packet = new DatagramPacket(buf, buf.length);
-                        multicastSocket.receive(packet);
+                        DatagramPacket packet = new DatagramPacket(this.buf, this.buf.length);
+                        this.multicastSocket.receive(packet);
                         String received = new String(packet.getData(), 0, packet.getLength());
                         if ("end".equals(received)) {
                             multiCastAlive = false;
@@ -76,11 +76,11 @@ public class ServerListenerThread extends Thread{
             }
         }
         try {
-            if (group != null) multicastSocket.leaveGroup(group);
+            if (group != null) this.multicastSocket.leaveGroup(group);
         } catch (IOException e) {
             LOGGER.error("", e);
         }
-        if (multicastSocket != null) multicastSocket.close();
+        if (this.multicastSocket != null) this.multicastSocket.close();
     }
 
     public void receivedLocalServer(DatagramPacket packet, String localServerBroadcast) {
@@ -116,13 +116,13 @@ public class ServerListenerThread extends Thread{
             } catch (Exception e) {
                 return;
             }
-            serverManager.onLocalScanned(ip, portInt, motd, name);
+            this.serverManager.onLocalScanned(ip, portInt, motd, name);
         }
     }
 
     public void handleIncomingServerInfo(ServerEntry server) {
-        synchronized (pingThreads) {
-            ThreadPingServer pingServer = pingThreads.remove(server);
+        synchronized (this.pingThreads) {
+            ThreadPingServer pingServer = this.pingThreads.remove(server);
             if (pingServer != null) {
                 pingServer.interrupt();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java b/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java
index e4a81f47e..47078dcd5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ServerManager.java
@@ -73,6 +73,7 @@ public class ServerManager {
     }
 
     private final @NotNull ScreenSelectServer attachedScreen;
+
     private ServerManager(@NotNull ScreenSelectServer attachedScreen, @NotNull CompoundTag compoundTag) {
         this.attachedScreen = attachedScreen;
 
@@ -102,14 +103,14 @@ public class ServerManager {
             UUID uuid = UUID.fromString(e.getKey());
             if (this.idToEntryMap.containsKey(uuid)) {
                 ServerEntry entry = this.idToEntryMap.get(uuid);
-                entry.lastPlayedTime = ((LongTag)e.getValue()).getValue();
+                entry.lastPlayedTime = ((LongTag) e.getValue()).getValue();
                 if (!this.historyMap.containsKey(entry.uuid)) {
                     this.historyMap.put(entry.uuid, entry);
                     this.history.add(entry);
                 }
             }
         }
-        history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
+        this.history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
 
     }
 
@@ -149,35 +150,35 @@ public class ServerManager {
     }
 
     public void addEntry(@NotNull ServerEntry entry) {
-        idToEntryLock.lock();
+        this.idToEntryLock.lock();
         try {
-            idToEntryMap.put(entry.uuid, entry);
+            this.idToEntryMap.put(entry.uuid, entry);
         } finally {
-            idToEntryLock.unlock();
+            this.idToEntryLock.unlock();
         }
     }
 
     public void addFavorite(@NotNull ServerEntry entry) {
         addEntry(entry);
-        if (!favoritesMap.containsKey(entry.uuid)) {
-            favoritesMap.put(entry.uuid, entry);
-            favorites.add(entry);
+        if (!this.favoritesMap.containsKey(entry.uuid)) {
+            this.favoritesMap.put(entry.uuid, entry);
+            this.favorites.add(entry);
         }
     }
 
     public void onJoined(@NotNull ServerEntry entry) {
         addEntry(entry);
         entry.lastPlayedTime = System.currentTimeMillis();
-        if (!historyMap.containsKey(entry.uuid)) {
-            historyMap.put(entry.uuid, entry);
-            history.add(entry);
+        if (!this.historyMap.containsKey(entry.uuid)) {
+            this.historyMap.put(entry.uuid, entry);
+            this.history.add(entry);
         }
-        history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
+        this.history.sort((o1, o2) -> Long.compare(o2.lastPlayedTime, o1.lastPlayedTime));
     }
 
     public void onLocalScanned(@NotNull String ip, int port, @Nullable String motd, @Nullable String name) {
         ServerAddress address = ServerAddress.resolveServerIP(String.format("%s:%s", ip, port));
-        if (!lanAddressMap.containsKey(address)) {
+        if (!this.lanAddressMap.containsKey(address)) {
             ServerEntry entry = new ServerEntry(UUID.randomUUID(), String.format("%s:%s", ip, port));
             if (name == null || name.isBlank()) {
                 entry.baseName = "Lan Server";
@@ -190,58 +191,58 @@ public class ServerManager {
             entry.dirty = true;
             entry.requestIcon = true;
             addEntry(entry);
-            lan.add(entry);
-            lanMap.put(entry.uuid, entry);
-            lanAddressMap.put(address, entry);
-            attachedScreen.needToRefreshPages = true;
+            this.lan.add(entry);
+            this.lanMap.put(entry.uuid, entry);
+            this.lanAddressMap.put(address, entry);
+            this.attachedScreen.needToRefreshPages = true;
         }
     }
 
     public void removeFavorite(@NotNull ServerEntry entry) {
-        favorites.remove(entry);
-        favoritesMap.remove(entry.uuid);
+        this.favorites.remove(entry);
+        this.favoritesMap.remove(entry.uuid);
         checkValid(entry);
     }
 
     public void removeHistory(@NotNull ServerEntry entry) {
-        history.remove(entry);
-        historyMap.remove(entry.uuid);
+        this.history.remove(entry);
+        this.historyMap.remove(entry.uuid);
         checkValid(entry);
     }
 
     public void checkValid(@NotNull ServerEntry entry) {
         if (
-            !favoritesMap.containsKey(entry.uuid) &&
-            !internetMap.containsKey(entry.uuid) &&
-            !historyMap.containsKey(entry.uuid) &&
-            !lanMap.containsKey(entry.uuid)
+            !this.favoritesMap.containsKey(entry.uuid) &&
+                !this.internetMap.containsKey(entry.uuid) &&
+                !this.historyMap.containsKey(entry.uuid) &&
+                !this.lanMap.containsKey(entry.uuid)
         ) {
-            idToEntryMap.remove(entry.uuid);
+            this.idToEntryMap.remove(entry.uuid);
         }
     }
 
     public void freeResources() {
-        idToEntryLock.lock();
+        this.idToEntryLock.lock();
         try {
-            idToEntryMap.forEach((uuid, entry) -> entry.free());
+            this.idToEntryMap.forEach((uuid, entry) -> entry.free());
         } finally {
-            idToEntryLock.unlock();
+            this.idToEntryLock.unlock();
         }
     }
 
     public @NotNull Collection<ServerEntry> getFavorites() {
-        return favorites;
+        return this.favorites;
     }
 
     public @NotNull Collection<ServerEntry> getInternet() {
-        return internet;
+        return this.internet;
     }
 
     public @NotNull Collection<ServerEntry> getHistory() {
-        return history;
+        return this.history;
     }
 
     public @NotNull Collection<ServerEntry> getLan() {
-        return lan;
+        return this.lan;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
index 99ea59d47..e3134975e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/SeverDirectConnectComponent.java
@@ -3,15 +3,11 @@ package net.minecraft.client.gui.server;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.paged.PageComponent;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ServerAddress;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 
-import java.util.Map;
-import java.util.UUID;
-
 public class SeverDirectConnectComponent implements PageComponent {
     public final ScreenSelectServer attachedScreen;
     public TextFieldElement ipField;
@@ -23,24 +19,24 @@ public class SeverDirectConnectComponent implements PageComponent {
     }
     @Override
     public int getHeight() {
-        return attachedScreen.height / 2;
+        return this.attachedScreen.height / 2;
     }
 
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         int _x = x + width / 2 - this.ipField.width / 2;
-        int _y = attachedScreen.height / 2 - 40;
+        int _y = this.attachedScreen.height / 2 - 40;
 
-        attachedScreen.mc.font.render(Tessellator.instance, I18n.getInstance().translateKey("gui.select_server.popup.add.prompt.ip"), _x, _y).setShadow().call();
+        this.attachedScreen.mc.font.render(I18n.getInstance().translateKey("gui.select_server.popup.add.prompt.ip"), _x, _y).setShadow().call();
         this.ipField.xPosition = _x;
-        this.ipField.yPosition = attachedScreen.mc.font.getLastEndingY() + 1;
+        this.ipField.yPosition = this.attachedScreen.mc.font.getLastEndingY() + 1;
 
         this.ipField.drawTextBox();
-        this.ipField.updateCursor(attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
+        this.ipField.updateCursor(this.attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
 
         this.connectButton.xPosition = _x;
         this.connectButton.yPosition = this.ipField.yPosition + this.ipField.height + 2;
-        this.connectButton.drawButton(attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
+        this.connectButton.drawButton(this.attachedScreen.mc, x + relativeMouseX, y + relativeMouseY);
     }
 
     @Override
@@ -81,7 +77,7 @@ public class SeverDirectConnectComponent implements PageComponent {
         String ip = this.ipField.getText();
         ServerAddress address = ServerAddress.resolveServerIP(ip);
         if (address != null) {
-            attachedScreen.addressToJoin = address;
+            this.attachedScreen.addressToJoin = address;
 //            attachedScreen.serverManager.idToEntryLock.lock();
 //            try {
 //                for (Map.Entry<UUID, ServerEntry> entry : attachedScreen.serverManager.idToEntryMap.entrySet()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
index 8ff9ba60e..aa83e367f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
@@ -2,16 +2,18 @@ package net.minecraft.client.gui.toasts;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.Global;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
 
 import java.util.ArrayList;
 import java.util.Comparator;
@@ -28,11 +30,11 @@ public class GuiElementToastsHud extends Gui {
     private final Minecraft mc;
 
     public GuiElementToastsHud(Minecraft minecraft) {
-        mc = minecraft;
+        this.mc = minecraft;
     }
 
     public boolean isDisplayingToast(IToastable toast) {
-        for (ToastEntry entry : activeEntries){
+        for (ToastEntry entry : this.activeEntries){
             if (entry.toast.isEquivalentToast(toast)){
                 return true;
             }
@@ -41,20 +43,20 @@ public class GuiElementToastsHud extends Gui {
     }
 
     public void addToast(IToastable toast) {
-        if (activeEntries.size() >= MAX_SHOWN_ENTRIES){
-            overflowEntries.add(toast);
+        if (this.activeEntries.size() >= MAX_SHOWN_ENTRIES){
+            this.overflowEntries.add(toast);
             return;
         }
-        activeEntries.add(new ToastEntry(toast, System.currentTimeMillis()));
+        this.activeEntries.add(new ToastEntry(toast, System.currentTimeMillis()));
         toast.onToastStart();
         sortList();
     }
 
     public void endToast(IToastable toast){
-        for (int i = 0; i < activeEntries.size(); i++) {
-            ToastEntry entry = activeEntries.get(i);
+        for (int i = 0; i < this.activeEntries.size(); i++) {
+            ToastEntry entry = this.activeEntries.get(i);
             if (entry.toast.isEquivalentToast(toast)){
-                activeEntries.remove(i);
+                this.activeEntries.remove(i);
                 entry.toast.onToastEnd();
                 sortList();
                 return;
@@ -63,52 +65,45 @@ public class GuiElementToastsHud extends Gui {
     }
 
     protected void sortList(){
-        activeEntries.sort(ToastEntry.TOAST_SORTER);
+        this.activeEntries.sort(ToastEntry.TOAST_SORTER);
     }
 
     private void updateScale() {
-        GL11.glViewport(0, 0, mc.gameWindow.getWidthPixels(), mc.gameWindow.getHeightPixels());
-        GL11.glMatrixMode(GL11.GL_PROJECTION);
-        GL11.glLoadIdentity();
-        GL11.glMatrixMode(GL11.GL_MODELVIEW);
-        GL11.glLoadIdentity();
-        GL11.glClear(256);
-        GL11.glMatrixMode(GL11.GL_PROJECTION);
-        GL11.glLoadIdentity();
-        GL11.glOrtho(0.0D, mc.resolution.getExactScaledWidthScreenCoords(), mc.resolution.getExactScaledHeightScreenCoords(), 0.0D, 1000D, 3000D);
-        GL11.glMatrixMode(GL11.GL_MODELVIEW);
-        GL11.glLoadIdentity();
-        GL11.glTranslatef(0.0F, 0.0F, -2000F);
+        GL41.glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
+        GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
+        GLRenderer.projectionM4f().identity().ortho(0.0f, (float) this.mc.resolution.getExactScaledWidthScreenCoords(), (float) this.mc.resolution.getExactScaledHeightScreenCoords(), 0.0f, 1000f, 3000f);
+        GLRenderer.viewM4f().identity().translate(0.0f, 0.0f, -2000f);
+        GLRenderer.modelM4f().identity();
     }
 
     public void render(float partialTick)
     {
         if(Minecraft.hasPaidCheckTime > 0L) { // Puts unlicensed copy message at top left of screen
-            GL11.glDisable(GL11.GL_DEPTH_TEST);
-            GL11.glDepthMask(false);
+            GLRenderer.disableState(State.DEPTH_TEST);
+            GLRenderer.setDepthMask(false);
             Lighting.disable();
             String s = I18n.getInstance().translateKeyAndFormat("gui.achievement.label.unlicensed.1", Global.VERSION);
             String s1 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.2");
             String s2 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.3");
-            drawStringShadow(mc.font, s, 2, 2, 0xffffff);
-            drawStringShadow(mc.font, s1, 2, 11, 0xffffff);
-            drawStringShadow(mc.font, s2, 2, 20, 0xffffff);
-            GL11.glDepthMask(true);
-            GL11.glEnable(GL11.GL_DEPTH_TEST);
+            drawStringShadow(this.mc.font, s, 2, 2, 0xffffff);
+            drawStringShadow(this.mc.font, s1, 2, 11, 0xffffff);
+            drawStringShadow(this.mc.font, s2, 2, 20, 0xffffff);
+            GLRenderer.setDepthMask(true);
+            GLRenderer.enableState(State.DEPTH_TEST);
         }
 
-        if (!overflowEntries.isEmpty()){
-            while (activeEntries.size() < MAX_SHOWN_ENTRIES && !overflowEntries.isEmpty()){
-                IToastable toast = overflowEntries.get(0);
-                overflowEntries.remove(0);
-                activeEntries.add(new ToastEntry(toast, System.currentTimeMillis() + 1));
+        if (!this.overflowEntries.isEmpty()){
+            while (this.activeEntries.size() < MAX_SHOWN_ENTRIES && !this.overflowEntries.isEmpty()){
+                IToastable toast = this.overflowEntries.get(0);
+                this.overflowEntries.remove(0);
+                this.activeEntries.add(new ToastEntry(toast, System.currentTimeMillis() + 1));
                 toast.onToastStart();
                 sortList();
             }
         }
 
         // Remove finished entries
-        List<ToastEntry> entriesCopy = new ArrayList<>(activeEntries);
+        List<ToastEntry> entriesCopy = new ArrayList<>(this.activeEntries);
         for (ToastEntry entry : entriesCopy){
             long duration = System.currentTimeMillis() - entry.startTime;
             double animProgress = entry.toast.getAnimationProgress(duration);
@@ -117,18 +112,18 @@ public class GuiElementToastsHud extends Gui {
             }
         }
 
-        if(activeEntries.isEmpty() || mc.thePlayer == null) {
+        if(this.activeEntries.isEmpty() || this.mc.thePlayer == null) {
             return;
         }
         updateScale();
 
 
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glDepthMask(false);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(false);
 
         int yOff = 0;
-        GL11.glEnable(GL11.GL_BLEND);
-        for (ToastEntry entry : activeEntries){ // Render all entries
+        GLRenderer.enableState(State.BLEND);
+        for (ToastEntry entry : this.activeEntries){ // Render all entries
             long duration = System.currentTimeMillis() - entry.startTime;
 
             double animProgress = entry.toast.getAnimationProgress(duration);
@@ -145,7 +140,7 @@ public class GuiElementToastsHud extends Gui {
             }
             hideAmount *= hideAmount;
             hideAmount *= hideAmount;
-            int toastLeft = mc.resolution.getScaledWidthScreenCoords() - TOAST_WIDTH;
+            int toastLeft = this.mc.resolution.getScaledWidthScreenCoords() - TOAST_WIDTH;
             int toastTop = (int) (-hideAmount * TOAST_HEIGHT);
             if (toastTop < 0) {
                 Scissor.enable(toastLeft, yOff, TOAST_WIDTH, TOAST_HEIGHT);
@@ -154,45 +149,38 @@ public class GuiElementToastsHud extends Gui {
             Scissor.disable();
             yOff += TOAST_HEIGHT + toastTop;
         }
-        GL11.glDisable(GL11.GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
 
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         Lighting.disable();
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.disableState(State.DEPTH_TEST);
     }
     protected void renderToast(IToastable toast, long duration, int x, int y){
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glDisable(GL11.GL_LIGHTING);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.globalSetLightEnabled(false);
 
         drawGuiIcon(x, y, TOAST_WIDTH, TOAST_HEIGHT, TextureRegistry.getTexture(toast.getTexture(duration)));
         if(toast.messageOnly(duration)) {
-            drawStringConstrained(mc.font, toast.getMessage(duration), x + 30, y + 7, 120, toast.messageColor(duration));
+            drawStringConstrained(this.mc.font, toast.getMessage(duration), x + 30, y + 7, 120, toast.messageColor(duration));
         } else {
-            drawStringNoShadow(mc.font, toast.getTitle(duration), x + 30, y + 7, toast.titleColor(duration));
-            drawStringNoShadow(mc.font, toast.getMessage(duration), x + 30, y + 18, toast.messageColor(duration));
+            drawStringNoShadow(this.mc.font, toast.getTitle(duration), x + 30, y + 7, toast.titleColor(duration));
+            drawStringNoShadow(this.mc.font, toast.getMessage(duration), x + 30, y + 18, toast.messageColor(duration));
         }
 
-        GL11.glDepthMask(true);
+        GLRenderer.setDepthMask(true);
         Lighting.enableInventoryLight();
-        GL11.glColor4f(1, 1, 1, 1);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.setColor4f(1, 1, 1, 1);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        GLRenderer.enableState(State.DEPTH_TEST);
         ItemStack icon = toast.getIcon(duration);
-//        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, icon, x + 8, y + 8, 1.0f);
-        if (icon != null) ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(Tessellator.instance, null, icon, x + 8, y + 8, 1f, 1f, 1.0f);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+//        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, icon, x + 8, y + 8, 1.0f);
+        if (icon != null) ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(GLRenderer.getTessellator(), null, icon, x + 8, y + 8, LightmapHelper.getLightmapCoord(15, 15), 1.0f);
+        GLRenderer.disableState(State.DEPTH_TEST);
     }
 
-    static class ToastEntry {
-        public static final Comparator<ToastEntry> TOAST_SORTER = (o1, o2) -> (int) (o1.startTime - o2.startTime);
-        public final long startTime;
-        public final IToastable toast;
-        public ToastEntry(IToastable toast, long startTime){
-            this.toast = toast;
-            this.startTime = startTime;
-        }
+    record ToastEntry(@NotNull IToastable toast, long startTime) {
+            public static final Comparator<ToastEntry> TOAST_SORTER = (o1, o2) -> (int) (o1.startTime - o2.startTime);
     }
 }
